//+------------------------------------------------------------------+
//|                                               SuperTrend nrp.mq4 |
//+------------------------------------------------------------------+
#property copyright "copyleft www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 clrDeepSkyBlue
#property indicator_color2 clrSandyBrown
#property indicator_color3 clrSandyBrown
#property indicator_width3 2
#property indicator_width4 2
#property indicator_width5 2
#property indicator_style3 STYLE_DOT
#property strict

//
//
//
//
//

#define _disBar 0x010
#define _disLin 0x001
#define _disZer 0x100
enum enDisplayType
{
   dis_01=_disLin,                // Display super trend line
   dis_02=_disBar,                // Display super trend bars
   dis_03=_disZer,                // Display super trend "zero" line
   dis_04=_disLin+_disBar,        // Display super trend line and bars
   dis_05=_disLin+_disZer,        // Display super trend line and "zero" line
   dis_06=_disBar+_disZer,        // Display super trend bars and "zero" line
   dis_07=_disLin+_disBar+_disZer // Display all
};
enum enPrices
{
   pr_close,      // Close
   pr_open,       // Open
   pr_high,       // High
   pr_low,        // Low
   pr_median,     // Median
   pr_typical,    // Typical
   pr_weighted,   // Weighted
   pr_average,    // Average (high+low+open+close)/4
   pr_medianb,    // Average median body (open+close)/2
   pr_tbiased,    // Trend biased price
   pr_tbiased2,   // Trend biased (extreme) price
   pr_haclose,    // Heiken ashi close
   pr_haopen ,    // Heiken ashi open
   pr_hahigh,     // Heiken ashi high
   pr_halow,      // Heiken ashi low
   pr_hamedian,   // Heiken ashi median
   pr_hatypical,  // Heiken ashi typical
   pr_haweighted, // Heiken ashi weighted
   pr_haaverage,  // Heiken ashi average
   pr_hamedianb,  // Heiken ashi median body
   pr_hatbiased,  // Heiken ashi trend biased price
   pr_hatbiased2  // Heiken ashi trend biased (extreme) price
};

extern ENUM_TIMEFRAMES TimeFrame     = PERIOD_CURRENT; // Time frame
extern int             CCIperiod     = 50;             // CCI period
extern enPrices        applied_price = 5;              // Price
extern int             ATRperiod     = 10;             // ATR period
extern double          ATRMultiplier = 1;              // ATR multiplier
input enDisplayType    DisplayWhat     = _disLin+_disBar; // Display type
input color            ColorUp         = clrLimeGreen; // Color for up
input color            ColorDn         = clrOrangeRed; // Color for down
input color            ColorNe         = clrDarkGray;  // Color for neutral and "zero" line
extern bool            Interpolate   = true;           // Interpolate in multi time frame mode?
//
//
//
//
//

double Trend[],TrendDoA[],TrendDoB[],Direction[],prices[],histou[],histod[],zero[];

string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
      int czer = ((DisplayWhat&_disZer)==0) ? clrNONE : ColorNe;
      int chup = ((DisplayWhat&_disBar)==0) ? clrNONE : ColorUp;
      int chdn = ((DisplayWhat&_disBar)==0) ? clrNONE : ColorDn;
      int clup = ((DisplayWhat&_disLin)==0) ? clrNONE : ColorUp;
      int cldn = ((DisplayWhat&_disLin)==0) ? clrNONE : ColorDn;
         SetIndexBuffer(0,histou);   SetIndexStyle(0,DRAW_HISTOGRAM,EMPTY,EMPTY,chup);
         SetIndexBuffer(1,histod);   SetIndexStyle(1,DRAW_HISTOGRAM,EMPTY,EMPTY,chdn);
         SetIndexBuffer(2,zero);     SetIndexStyle(2,EMPTY,STYLE_DOT,0,czer);
         SetIndexBuffer(3,Trend);    SetIndexStyle(3,EMPTY,EMPTY,EMPTY,clup);
         SetIndexBuffer(4,TrendDoA); SetIndexStyle(4,EMPTY,EMPTY,EMPTY,cldn);
         SetIndexBuffer(5,TrendDoB); SetIndexStyle(5,EMPTY,EMPTY,EMPTY,cldn);
         SetIndexBuffer(6,Direction);
         SetIndexBuffer(7,prices);
      
      //
      //
      //
      //
      //
     
        indicatorFileName = WindowExpertName();
        returnBars        = (TimeFrame==-99);
        TimeFrame         = MathMax(TimeFrame,_Period);  
      IndicatorShortName(timeFrameToString(TimeFrame)+"  SuperTrend nrp");
return(0);
}  
int deinit() {  return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
           int limit = MathMin(Bars-counted_bars,Bars-1); 
           if (returnBars) { histou[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (TimeFrame==Period())
   {
     if (Direction[limit] == -1) CleanPoint(limit,TrendDoA,TrendDoB);
     for(int i=limit; i>=0; i--)
     {
         prices[i] = getPrice(applied_price,Open,Close,High,Low,i);
         double avg      = 0; for(int k=0; k<CCIperiod && (i+k)<Bars; k++) avg +=         prices[i+k];      avg /= CCIperiod;
         double dev      = 0; for(int k=0; k<CCIperiod && (i+k)<Bars; k++) dev += MathAbs(prices[i+k]-avg); dev /= CCIperiod;
         double cciTrend = (dev!=0) ? (prices[i]-avg)/(0.015*dev) : 0;
         zero[i] = avg;
         
         //
         //
         //
         //
         //
         
         TrendDoA[i]  = EMPTY_VALUE;
         TrendDoB[i]  = EMPTY_VALUE;
         Trend[i]     = (i<Bars-1) ? Trend[i+1] : prices[i];
         Direction[i] = (i<Bars-1) ? Direction[i+1] : 0;
                    if ((i<Bars-1) && cciTrend > 0) { Trend[i] = MathMax(Low[i]  - iATR(NULL,0,ATRperiod,i)*ATRMultiplier,Trend[i+1]); Direction[i] =  1; }
                    if ((i<Bars-1) && cciTrend < 0) { Trend[i] = MathMin(High[i] + iATR(NULL,0,ATRperiod,i)*ATRMultiplier,Trend[i+1]); Direction[i] = -1; }
         if (Direction[i]==-1) PlotPoint(i,TrendDoA,TrendDoB,Trend);
         if (Direction[i]== 1) { histou[i] = High[i]; histod[i] = Low[i]; }
         if (Direction[i]==-1) { histod[i] = High[i]; histou[i] = Low[i]; }
      }
   return(0);
   }
   
   //
   //
   //
   //
   //
   
   #define _mtfCall(_buff,_y) iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,CCIperiod,applied_price,ATRperiod,ATRMultiplier,_buff,_y)
   limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   if (Direction[limit] == -1) CleanPoint(limit,TrendDoA,TrendDoB);
   for (int i=limit;i>=0; i--)
   {
       int y = iBarShift(NULL,TimeFrame,Time[i]);
          zero[i]      = _mtfCall(2,y);
          Trend[i]     = _mtfCall(3,y);
          Direction[i] = _mtfCall(6,y);;
          TrendDoA[i]  = EMPTY_VALUE;
          TrendDoB[i]  = EMPTY_VALUE;
          if (Direction[i] == -1) PlotPoint(i,TrendDoA,TrendDoB,Trend);
          if (Direction[i] ==  1) { histou[i] = High[i]; histod[i] = Low[i]; }
          if (Direction[i] == -1) { histod[i] = High[i]; histou[i] = Low[i]; }
          if (!Interpolate || (i>0 && y==iBarShift(NULL,TimeFrame,Time[i-1]))) continue;
                  
          //
          //
          //
          //
          //
                  
          #define _interpolate(buff,i,k,n) buff[i+k] = buff[i]+(buff[i+n]-buff[i])*k/n
            int n,k; datetime time = iTime(NULL,TimeFrame,y);
               for(n = 1; (i+n)<Bars && Time[i+n] >= time; n++) continue;	
               for(k = 1; k<n && (i+n)<Bars && (i+k)<Bars; k++) _interpolate(zero,i,k,n);
   }
   return(0);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>=Bars-3) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
      if (first[i+2] == EMPTY_VALUE) 
            { first[i]  = from[i];  first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
      else  { second[i] =  from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else     { first[i]  = from[i];                           second[i] = EMPTY_VALUE; }
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//
//

#define priceInstances 1
double workHa[][priceInstances*4];
double getPrice(int tprice, const double& open[], const double& close[], const double& high[], const double& low[], int i, int instanceNo=0)
{
  if (tprice>=pr_haclose)
   {
      if (ArrayRange(workHa,0)!= Bars) ArrayResize(workHa,Bars); instanceNo*=4;
         int r = Bars-i-1;
         
         //
         //
         //
         //
         //
         
         double haOpen;
         if (r>0)
                haOpen  = (workHa[r-1][instanceNo+2] + workHa[r-1][instanceNo+3])/2.0;
         else   haOpen  = (open[i]+close[i])/2;
         double haClose = (open[i] + high[i] + low[i] + close[i]) / 4.0;
         double haHigh  = MathMax(high[i], MathMax(haOpen,haClose));
         double haLow   = MathMin(low[i] , MathMin(haOpen,haClose));

         if(haOpen  <haClose) { workHa[r][instanceNo+0] = haLow;  workHa[r][instanceNo+1] = haHigh; } 
         else                 { workHa[r][instanceNo+0] = haHigh; workHa[r][instanceNo+1] = haLow;  } 
                                workHa[r][instanceNo+2] = haOpen;
                                workHa[r][instanceNo+3] = haClose;
         //
         //
         //
         //
         //
         
         switch (tprice)
         {
            case pr_haclose:     return(haClose);
            case pr_haopen:      return(haOpen);
            case pr_hahigh:      return(haHigh);
            case pr_halow:       return(haLow);
            case pr_hamedian:    return((haHigh+haLow)/2.0);
            case pr_hamedianb:   return((haOpen+haClose)/2.0);
            case pr_hatypical:   return((haHigh+haLow+haClose)/3.0);
            case pr_haweighted:  return((haHigh+haLow+haClose+haClose)/4.0);
            case pr_haaverage:   return((haHigh+haLow+haClose+haOpen)/4.0);
            case pr_hatbiased:
               if (haClose>haOpen)
                     return((haHigh+haClose)/2.0);
               else  return((haLow+haClose)/2.0);        
            case pr_hatbiased2:
               if (haClose>haOpen)  return(haHigh);
               if (haClose<haOpen)  return(haLow);
                                    return(haClose);        
         }
   }
   
   //
   //
   //
   //
   //
   
   switch (tprice)
   {
      case pr_close:     return(close[i]);
      case pr_open:      return(open[i]);
      case pr_high:      return(high[i]);
      case pr_low:       return(low[i]);
      case pr_median:    return((high[i]+low[i])/2.0);
      case pr_medianb:   return((open[i]+close[i])/2.0);
      case pr_typical:   return((high[i]+low[i]+close[i])/3.0);
      case pr_weighted:  return((high[i]+low[i]+close[i]+close[i])/4.0);
      case pr_average:   return((high[i]+low[i]+close[i]+open[i])/4.0);
      case pr_tbiased:   
               if (close[i]>open[i])
                     return((high[i]+close[i])/2.0);
               else  return((low[i]+close[i])/2.0);        
      case pr_tbiased2:   
               if (close[i]>open[i]) return(high[i]);
               if (close[i]<open[i]) return(low[i]);
                                     return(close[i]);        
   }
   return(0);
}   